/*******************************************************
 * TIC TAC TOE Game                                    *
 * by Parthipan Siva                                   *
 *                                                     *
 * Created as demonstration of OOP for                 *
 * SD121 course.                                       *
 *                                                     *
 *  Nov 2005   created                 - Parthipan     *
 *  Nov 2006   added more comments     - Parthipan     *
 *                                                     *
 *******************************************************/
 
#include "HumanPlayer.h"

HumanPlayer::HumanPlayer()
{
}

void HumanPlayer::playAMove(GameBoard& currentBoard)
{
     int row=-1, col=-1;
     int returnStatus = 0;
     while (returnStatus != 1)
     {
           getLocationFromPlayer(row,col);
           if (row != -10 && col != -10)
           {
               if (get_piece() == get_X_VAL())
                   returnStatus = currentBoard.x_move(row-1, col-1);
               else
                   returnStatus = currentBoard.o_move(row-1, col-1);
               if (returnStatus == -1)
               {
                   cout << "Invalid place to put your piece." << endl;
               }
           }
           else
           {
               currentBoard.quitGame();
               returnStatus = 1;
           }
     }
}

void HumanPlayer::getLocationFromPlayer(int& row, int& col)
{
     // used to read the user input
     string line;
     // used to check if the row and col numbers were obtained correctly from
     // user.
     bool gotRow = false;
     bool gotCol = false;
     
     // initialize row and col locations to 0 first
     row = 0;
     col = 0;
     
     while (row < 1 || row > 3 || col < 1 || col > 3)
     {
         cout << "Where whould you like to place your piece?" << endl;
         cout << "Please enter row and col eg: 2 3 OR q to quit" << endl;
         // read in the users response as string
         getline(cin, line, '\n');
         gotRow = false;
         gotCol = false;
     
         // Loop through all the chars in the string to obtain the inputs
         for (int i = 0; i < line.length(); i++)
         {
             // ignore all spaces
             if (line[i] == ' ')
             {
             }
             else if (line[i] >= '1' && line[i] <= '3')
             {
                  // get the 1st 2 digits between 1 and 3 as the user inputs
                  // for row and col locations
                  // Ignore all other digits
                  if (gotRow == true && gotCol == false)
                  {
                      col = int(line[i])-int('0');
                      gotCol = true;
                  }
                  else if (gotRow == false && gotCol == false)
                  {
                      row = int(line[i])-int('0');
                      gotRow = true;
                  }
             }
             else if (line[i] == 'Q' || line[i] == 'q')
             {
                  // Q is for quiting
                  row = -10;
                  col = -10;
                  return;
             }
             else
             {
                  cout << " Your entry is invalid. " << endl;
                  break;
             }
         }
         if (gotRow == false || gotCol == false)
         {
             // if both row and col were not obtained properly
             cout << " Your entry is invalid. " << endl;
             // reset both row and col and ask user again
             gotRow = false;
             gotCol = false;
             row = 0;
             col = 0;
         }
     }
}
