/*******************************************************
 * TIC TAC TOE Game                                    *
 * by Parthipan Siva                                   *
 *                                                     *
 * Created as demonstration of OOP for                 *
 * SD121 course.                                       *
 *                                                     *
 *  Nov 2005   created                 - Parthipan     *
 *  Nov 2006   added more comments     - Parthipan     *
 *                                                     *
 *******************************************************/
 
 /*
 This is a HumanPlayer class for a TicTacToe game. It
 will ask the user to place an X or O in a valid location
 on the game board.
 
 This class requires the use of the GameBoard, Player.
 */
 
#ifndef HUMANPLAYER_H
#define HUMANPLAYER_H

#include "Player.h"
#include "GameBoard.h"

class HumanPlayer : public Player
{
public:

    HumanPlayer();
    
    // Place a piece
    // INPUT: currentBoard - is the game board on which to place a piece
    void playAMove(GameBoard& currentBoard);

private:

    // Get the place where the user wants to place the piece
    // INPUT: (row, col) is the location where to place the piece
    // SIDE EFFECT: Only the 1st 2 digits are accepted as valid inputs
    //              For example 23432 is entered the row is taken as 2 and
    //              column is taken as 3.
    void getLocationFromPlayer(int& row, int& col);
};

#endif
